# class SS7TCAPTransactionITU | ITU-T SS7 TCAP transaction implementation. More...
Full name | `TelEngine::SS7TCAPTransactionITU`
Definition | `#include <libs/ysig/yatesig.h>`
Inherits | TelEngine::SS7TCAPTransaction [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum ITUComponentType { CompUnknown = 0x0, Local = 0x1, Invoke = 0xa1, ReturnResultLast = 0xa2, ReturnError = 0xa3, Reject = 0xa4, ReturnResultNotLast = 0xa7, }
- enum ITUTransactionType { Unknown = 0x0, Unidirectional = 0x61, Begin = 0x62, End = 0x64, Continue = 0x65, Abort = 0x67, }
- enum ITUDialogTags { AARQDialogTag = 0x60, AAREDialogTag = 0x61, ABRTDialogTag = 0x64, ResultDiagnosticUserTag = 0xa1, ResultDiagnosticProviderTag = 0xa2, ResultTag = 0xa2, ResultDiagnosticTag = 0xa3, }
- enum ITUDialogValues { ResultAccepted = 0, ResultRejected = 1, DiagnosticUserNull = 0x10, DiagnosticUserNoReason = 0x11, DiagnosticUserAppCtxtNotSupported = 0x12, DiagnosticProviderNull = 0x20, DiagnosticProviderNoReason = 0x21, DiagnosticProviderNoCommonDialog = 0x22, AbortSourceUser = 0x30, AbortSourceProvider = 0x31, }

#### Public Methods

- SS7TCAPTransactionITU (SS7TCAP* tcap, SS7TCAP::TCAPUserTransActions type, const String& transactID, NamedList& params, u_int64_t timeout, bool initLocal = true)
- ~SS7TCAPTransactionITU ()
- virtual SS7TCAPError handleData (NamedList& params, DataBlock& data)
- virtual SS7TCAPError update (SS7TCAP::TCAPUserTransActions type, NamedList& params, bool updateByUser = true)
- virtual SS7TCAPError handleDialogPortion (NamedList& params, bool byUser = true)
- virtual void updateToEnd ()
- inline bool dialogPresent ()
- bool testForDialog (DataBlock& data)
- void encodeDialogPortion (NamedList& params, DataBlock& data)
- SS7TCAPError decodeDialogPortion (NamedList& params, DataBlock& data)
- void updateState (bool byUser = false)
- virtual void requestContent (NamedList& params, DataBlock& data)
- virtual void abnormalDialogInfo (NamedList& params)

#### Public Static Methods

- static void encodePAbort (SS7TCAPTransaction* tr, NamedList& params, DataBlock& data)
- static SS7TCAPError decodePAbort (SS7TCAPTransaction* tr, NamedList& params, DataBlock& data)

#### Public Members

- static const TokenDict s_dialogPDUs[]
- static const TokenDict s_resultPDUValues[]

## Detailed Description

Implementation of SS7 Transactional Capabilities Application Part Transaction - specification ITU-T

enum ITUComponentType { CompUnknown = 0x0, Local = 0x1, Invoke = 0xa1, ReturnResultLast = 0xa2, ReturnError = 0xa3, Reject = 0xa4, ReturnResultNotLast = 0xa7, } | ### ITUComponentType

enum ITUTransactionType { Unknown = 0x0, Unidirectional = 0x61, Begin = 0x62, End = 0x64, Continue = 0x65, Abort = 0x67, } | ### ITUTransactionType

enum ITUDialogTags { AARQDialogTag = 0x60, AAREDialogTag = 0x61, ABRTDialogTag = 0x64, ResultDiagnosticUserTag = 0xa1, ResultDiagnosticProviderTag = 0xa2, ResultTag = 0xa2, ResultDiagnosticTag = 0xa3, } | ### ITUDialogTags

enum ITUDialogValues { ResultAccepted = 0, ResultRejected = 1, DiagnosticUserNull = 0x10, DiagnosticUserNoReason = 0x11, DiagnosticUserAppCtxtNotSupported = 0x12, DiagnosticProviderNull = 0x20, DiagnosticProviderNoReason = 0x21, DiagnosticProviderNoCommonDialog = 0x22, AbortSourceUser = 0x30, AbortSourceProvider = 0x31, } | ### ITUDialogValues

SS7TCAPTransactionITU (SS7TCAP* tcap, SS7TCAP::TCAPUserTransActions type, const String& transactID, NamedList& params, u_int64_t timeout, bool initLocal = true) | ### SS7TCAPTransactionITU

Constructor

Parameters:

tcap | TCAP holding this transaction
type | Initiating type for transaction
transactID | Transaction ID
params | Parameters to build this transaction
timeout | Transaction time out interval
initLocal | True if the transaction was initiated locally, false if not

~SS7TCAPTransactionITU () | ### ~SS7TCAPTransactionITU

Destructor

SS7TCAPError handleData (NamedList& params, DataBlock& data) | ### handleData

[virtual]

Process transaction data and fill the NamedList with the decoded data

Parameters:

params | NamedList to fill with decoded data
data | Data to decode

Returns: A TCAP error encountered whilst decoding

Reimplemented from SS7TCAPTransaction.

SS7TCAPError update (SS7TCAP::TCAPUserTransActions type, NamedList& params, bool updateByUser = true) | ### update

[virtual]

An update request for this transaction

Parameters:

type | The type of transaction to which this transaction should be updated
params | Update parameter
updateByUser | True if the update is made by the local user, false if it's made by the remote end

Returns: A TCAP Error

Reimplemented from SS7TCAPTransaction.

SS7TCAPError handleDialogPortion (NamedList& params, bool byUser = true) | ### handleDialogPortion

[virtual]

Handle TCAP relevant dialog data

Parameters:

params | NamedList containing (if present) dialog information
byUser | True if the dialog information is provided by the local user, false otherwise

Returns: A report error

Reimplemented from SS7TCAPTransaction.

void encodePAbort (SS7TCAPTransaction* tr, NamedList& params, DataBlock& data) | ### encodePAbort

[static]

Encode P-Abort information

Parameters:

tr | The transaction on which the abort was signalled
params | NamedList reference from which to get the P-Abort information
data | DataBlock reference in which to insert the encoded P-Abort information

SS7TCAPError decodePAbort (SS7TCAPTransaction* tr, NamedList& params, DataBlock& data) | ### decodePAbort

[static]

Decode P-Abort TCAP message portion

Parameters:

tr | The transaction on which the abort was signalled
params | NamedList reference to fill with the decoded P-Abort information
data | DataBlock reference from which to decode P-Abort information

Returns: A report error

void updateToEnd () | ### updateToEnd

[virtual]

Update the state of this transaction to end the transaction

Reimplemented from SS7TCAPTransaction.

inline bool dialogPresent () | ### dialogPresent

Check if the transaction present dialog information

Returns: True if dialog information is present, false otherwise

bool testForDialog (DataBlock& data) | ### testForDialog

Test for dialog when decoding

Parameters:

data | Data from which the transaction is decoded

Returns: True if dialog portion is present, false otherwise

void encodeDialogPortion (NamedList& params, DataBlock& data) | ### encodeDialogPortion

Encode dialog portion of transaction

Parameters:

params | List of parameters to encode
data | Data block into which to insert the encoded data

Reimplemented from SS7TCAPTransaction.

SS7TCAPError decodeDialogPortion (NamedList& params, DataBlock& data) | ### decodeDialogPortion

Decode dialog portion

Parameters:

params | List into which to put the decoded dialog parameters
data | Data to decodeCaps

Returns: A report error

Reimplemented from SS7TCAPTransaction.

void updateState (bool byUser = false) | ### updateState

Update transaction state

Parameters:

byUser | True if update is requested by user, false if by remote

Reimplemented from SS7TCAPTransaction.

void requestContent (NamedList& params, DataBlock& data) | ### requestContent

[virtual]

Request content for this transaction

Parameters:

params | List of parameters of this tranaction
data | Data block to fill with encoded content

Reimplemented from SS7TCAPTransaction.

void abnormalDialogInfo (NamedList& params) | ### abnormalDialogInfo

[virtual]

Set information in case of abnormal dialog detection

Parameters:

params | List of parameters where to set the abnormal dialog information

Reimplemented from SS7TCAPTransaction.

static const TokenDict s_dialogPDUs[] | ### s_dialogPDUs[]

static const TokenDict s_resultPDUValues[] | ### s_resultPDUValues[]

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.